FROM ubuntu:24.04

ARG SERVICE
ARG HOSTNAME
ARG PORT=443
ARG MKCERT_VERSION=v1.4.4

RUN apt-get update -y
RUN apt-get install -y wget libnss3-tools stunnel4
RUN wget -O /usr/bin/mkcert https://github.com/FiloSottile/mkcert/releases/download/${MKCERT_VERSION}/mkcert-${MKCERT_VERSION}-linux-amd64
RUN chmod +x /usr/bin/mkcert
RUN mkcert -install
RUN mkdir /cert
RUN mkcert -key-file /cert/key.pem -cert-file /cert/cert.pem ${HOSTNAME}
RUN cat /cert/key.pem /cert/cert.pem > /cert/bundle.pem

ENV PORT ${PORT}
ENV SERVICE ${SERVICE}
CMD stunnel3 -f -d ${PORT} -r ${SERVICE} -p /cert/bundle.pem
